using Photon.Pun;
using System.Collections;
using System.Collections.Generic;
using UnityEngine;

[CreateAssetMenu(fileName = "GameEvent_ZoneData", menuName = "Wavefunction/Event/New GameEvent ZoneData", order = 1)]
public class GameEvent_ZoneData : ScriptableObject
{
    private List<GameEventListener_ZoneData> listeners = new List<GameEventListener_ZoneData>();

    public void Raise(ZoneData zoneData)
    {
        for (int i = listeners.Count - 1; i >= 0; i--)
        {
            listeners[i].OnEventRaised(zoneData);
        }
    }

    public void RegisterListener(GameEventListener_ZoneData listener)
    {
        listeners.Add(listener);
    }

    public void UnRegisterListener(GameEventListener_ZoneData listener)
    {
        listeners.Remove(listener);
    }
}
